// --------------------------------------------------------------------------------------
//
// AmpelMain.CS                                                    Ulrich Mller 17.06.02
//                                                                 PCS1700       C# Final
// Betrieb einer Fugngerampel in zwei eigenen Threads :
// frmMain      : MainThread Steuerung des Betriebsablaufs, Bedieneroberflche
// ampelAuto    : Thread     Steuerung der Autoampel
// ampelFuss    : Thread     Steuerung der Fugngerampel
// umFish30.DLL : Thread     Zugriff auf das Interface, durch MultiMediaTimer gesteuert
// ft           : Instanz    von FishFace, Zugriff auf das Interface ber umFish30.DLL
//
// Modell : Intelligent Interface mit Extensionmodul an COM1
//          AmpelAuto mit Grn M1, Gelb M2 und Rot M3
//          AmpelFuss mit Grn M5          und Rot M7
//
// --------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using FishFa30;

namespace AmpelThread
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblStrasse;
		private System.Windows.Forms.Label lblFuss;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Button cmdFuss;

		// --- FishFace : Klassen-Instanz -----------------------------------------------

		private FishFace ft = new FishFace(false, true, 0);
		private Thread   ampelAuto;              
		private Thread   ampelFuss;
		private AutoResetEvent autoRot;
		private AutoResetEvent fussRot;
		private AutoResetEvent fussWunsch;


		// --- Interface-Belegung -------------------------------------------------------

		const int mAutoGruen = 1, mAutoGelb = 2, mAutoRot = 3,
				  mFussGruen = 5,                mFussRot = 7,
				  ftiEin     = 1, ftiAus    = 0;

		private System.ComponentModel.Container components = null;

		// --- ftmMain : Konstruktor/Destruktor ----------------------------------------

		public frmMain()
		{
			InitializeComponent();
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblStrasse = new System.Windows.Forms.Label();
			this.lblFuss = new System.Windows.Forms.Label();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.cmdAction = new System.Windows.Forms.Button();
			this.cmdFuss = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// lblStrasse
			// 
			this.lblStrasse.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStrasse.Location = new System.Drawing.Point(16, 24);
			this.lblStrasse.Name = "lblStrasse";
			this.lblStrasse.Size = new System.Drawing.Size(288, 24);
			this.lblStrasse.TabIndex = 0;
			this.lblStrasse.Text = "StraenAmpel";
			this.lblStrasse.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblFuss
			// 
			this.lblFuss.Font = new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblFuss.Location = new System.Drawing.Point(16, 64);
			this.lblFuss.Name = "lblFuss";
			this.lblFuss.Size = new System.Drawing.Size(288, 24);
			this.lblFuss.TabIndex = 1;
			this.lblFuss.Text = "FugngerAmpel";
			this.lblFuss.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cmdEnde
			// 
			this.cmdEnde.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdEnde.Location = new System.Drawing.Point(192, 128);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(112, 32);
			this.cmdEnde.TabIndex = 2;
			this.cmdEnde.Text = "&ENDE";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// cmdAction
			// 
			this.cmdAction.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdAction.Location = new System.Drawing.Point(192, 176);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(112, 32);
			this.cmdAction.TabIndex = 3;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// cmdFuss
			// 
			this.cmdFuss.Enabled = false;
			this.cmdFuss.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdFuss.Location = new System.Drawing.Point(32, 152);
			this.cmdFuss.Name = "cmdFuss";
			this.cmdFuss.Size = new System.Drawing.Size(112, 32);
			this.cmdFuss.TabIndex = 4;
			this.cmdFuss.Text = "&FussWunsch";
			this.cmdFuss.Click += new System.EventHandler(this.cmdFuss_Click);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(328, 229);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdFuss,
																		  this.cmdAction,
																		  this.cmdEnde,
																		  this.lblFuss,
																		  this.lblStrasse});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.Text = "AmpelThread : Einfache Fugngerampel";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
			this.ResumeLayout(false);

		}
		#endregion

		// --- Der Haupteinstiegspunkt fr die Anwendung -------------------------------

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain
				());
		}

		
		// --- cmdEnde_Click : Beenden des Modellbetriebs bei Button = HALT 
		//     Beenden des Programms, bei Button = ENDE -------------------------------

		private void cmdEnde_Click(object sender, System.EventArgs e)
		{
			if(cmdEnde.Text == "&HALT")
			{
				// --- Beenden des Ampelbetriebes --------------------------------------
				lblStrasse.Text = "Beenden wird eingeleitet";
				ft.NotHalt = true;        // --- SchleifenEnde
				fussWunsch.Set();         // --- Fugngerphase schalten
				ampelAuto.Join();         // --- Warten auf Ende AutoThread
				ampelFuss.Join();         // --- Warten auf Ende FuThread

				ft.CloseInterface();      // --- Interface abschalten

				cmdAction.Enabled = true; // --- Buttons sortieren
				cmdFuss.Enabled = false;
				cmdEnde.Text = "&ENDE";
			}
			else
			{
				// --- Programmende --------------------------------------------------
				this.Close();
			}
		}

		// --- Schlieen der Form ablehnen, wenn das Modell noch luft ---------------

		private void frmMain_Closing(object sender, 
			System.ComponentModel.CancelEventArgs e)
		{
			if(cmdEnde.Text == "&HALT") e.Cancel = true;
		}

		// --- cmdAction_Click : Starten des Ampelbetriebes --------------------------

		private void cmdAction_Click(object sender, System.EventArgs e)
		{
			try
			{
				ft.OpenInterface(Port.COM1, false); // --- Verbindung zum Interface COM1
													//     ohne DoEvents
				cmdAction.Enabled = false;      // --- Buttons sortieren
				cmdEnde.Text      = "&HALT";
				lblStrasse.Text   = "StrassenAmpel luft";
				lblFuss.Text      = "FugngerAmpel luft";
				cmdFuss.Enabled   = true;
				cmdEnde.Focus();

				// --- Threads, Events instanzieren und starten -----------------------
				ampelAuto = new Thread(new ThreadStart(autoExecute));
				ampelFuss = new Thread(new ThreadStart(fussExecute));
				autoRot = new AutoResetEvent(false);
				fussRot = new AutoResetEvent(false);
				fussWunsch = new AutoResetEvent(false);		
				ampelAuto.Start();
				ampelFuss.Start();
			}
			catch(FishFaceException eft)
			{
				lblStrasse.Text = eft.Message;
				return;
			}
		}

		// --- cmdFuss_Click : Wunsch nach FugngerPhase anmelden ----------------

		private void cmdFuss_Click(object sender, System.EventArgs e)
		{
			fussWunsch.Set();
		}

		// --- autoExecute : Nutzroutine des AutoThread ---------------------------

		private void autoExecute()
		{
			do
			{
				// --- Ruhezustand ----------------------------------------------
				ft.SetMotor(mAutoGruen, ftiEin);
				lblStrasse.BackColor = Color.Lime;

				// --- Warten auf Anforderung FugngerPhase --------------------
				fussWunsch.WaitOne();

				// --- Schalten Gelb - Rot --------------------------------------
				ft.SetMotor(mAutoGruen, ftiAus);
				ft.SetMotor(mAutoGelb, ftiEin);
				lblStrasse.BackColor = Color.Yellow;
				ft.Pause(1500);
				ft.SetMotor(mAutoGelb, ftiAus);
				ft.SetMotor(mAutoRot, ftiEin);
				lblStrasse.BackColor = Color.Red;

				// --- Signalisieren : Rot ist geschaltet -----------------------
				autoRot.Set();

				// --- Warten auf Ende der Fugngerphase ----------------------
				fussRot.WaitOne();

				// --- Schalten Rot/Gelb - Grn ---------------------------------
				ft.SetMotor(mAutoGelb, ftiEin);
				lblStrasse.BackColor = Color.Maroon;
				ft.Pause(1000);
				ft.SetMotor(mAutoGelb, ftiAus);
				ft.SetMotor(mAutoRot, ftiAus);

			} while(!ft.Finish());
			lblStrasse.Text = "StraenAmpel steht";
		}
		
		// --- fussExecute : Nutzroutine des FussThreads -----------------------
		private void fussExecute()
		{
			do
			{
				// --- Ruhezustand ---------------------------------------------
				ft.SetMotor(mFussGruen, ftiAus);
				ft.SetMotor(mFussRot, ftiEin);
				lblFuss.BackColor = Color.Red;

				// --- Warten auf RotPhase der AutoAmpel -----------------------
				autoRot.WaitOne();

				// --- Schalten der Grn-Phase ---------------------------------
				ft.SetMotor(mFussRot, ftiAus);
				ft.SetMotor(mFussGruen, ftiEin);
				lblFuss.BackColor = Color.Lime;
				ft.Pause(3000);

				// --- Signalisieren : Grnphase ist beendet -------------------
				fussRot.Set();

			} while(!ft.Finish());
			lblFuss.Text = "FugngerAmpel steht";
		}

	}
}
